-------------------------------
-- String function extension --
-------------------------------

--[[
* Str:devide(pattern)
* string.devide(Str, pattern)

> string : a general string
> pattern: Lua pattern

< Table of strings
--]]

function string:devide(pattern)
	local out = {}
	local sp, ep, ssp, eep = 0, 0, 0, 0
	local len = #self
	local outp = 0
 
	while sp<len do
		ssp, eep = self:find(pattern, ep+1)
		if not ssp then ssp=len+1 end
		if ssp-ep>1 then
			outp = outp + 1
			out[outp] = self:sub(ep+1, ssp-1)
		end
		if eep then
			outp = outp + 1
			out[outp] = self:sub(ssp, eep)
		end
		sp = ssp
		ep = eep
	end
 
	return out
end
