--include "Construction.lua"
--include "Tools.lua"
--include "nspirelink.lua"
--include "HTMLobjects.lua"
--include "HTMLparser.lua"

msg = ""
function on.rpaint(gc)
	gc:setColorRGB(0)
	if msg then
		gc:drawString("Enter url:",10,10,"top")
		gc:drawString(msg,10,20,"top")
	end
	if doc then
		doc:paint(gc)
	end
end

function printtag(tag, l)
	l=l or 0
	print(string.rep("  ", l) .. (tag.tagtype or "huhtag"))
	for _, child in ipairs(tag.childs) do
		printtag(child, l+1)
	end
end

--printtag(doc.htmltree)

function on.rcharIn(ch)
	if msg then
		msg = msg .. ch
	end
	platform.window:invalidate()
end

function on.enterKey()
	if msg then
		link_send("HTTPFILE GET " .. msg)
		platform.window:invalidate()
		msg="Receiving data..."
	end
end

function on.receive(data)
	if data == "HF 1" then
		msg=nil
		webdata = var.recall("cache\\cache")
		doc=HTMLdocument(webdata)
		doc:parse()
		platform.window:invalidate()
	end
end

